//--------------------------------------------------------------------- 
#include "BFindWindow.h"
//--------------------------------------------------------------------- 
BFindWindow::BFindWindow(BRect frame,const char *title,
                    const BString &findword,const BString &replaceword,
                    const bool ignorecase) 
    :BWindow(frame,title,FINDWINDOW_WINDOWSTYLE,0) 
{ 
    BFindView *findview=new BFindView(Bounds(),findword,replaceword,
                                      ignorecase);
    AddChild(findview); 

    SetDefaultButton((BButton *)findview->FindView("btnfind"));
    findview->FindView("txtfind")->MakeFocus();
} 
//--------------------------------------------------------------------- 
void BFindWindow::MessageReceived(BMessage *msg) 
{ 
    switch(msg->what) 
    { 
        case MSG_FIND: 
        case MSG_REPLACEALL:
            {
                msg->AddString("findword",
                    ((BTextControl *)FindView("txtfind"))->Text());
                msg->AddString("replaceword",
                    ((BTextControl *)FindView("txtrepl"))->Text());
                msg->AddBool("ignorecase",
                    (((BCheckBox *)FindView("chkcase"))->Value()
                                                   ==B_CONTROL_ON));
                be_app->PostMessage(msg);

                PostMessage(B_QUIT_REQUESTED);
            } 
            break;        
        default: 
            BWindow::MessageReceived(msg); 
    } 
} 
//--------------------------------------------------------------------- 
BFindView::BFindView(BRect frame,
                    const BString &findword,const BString &replaceword,
                    const bool ignorecase) 
    :BView(frame,"findview",B_FOLLOW_ALL,B_WILL_DRAW) 
{ 
    BTextControl *txtfind=new BTextControl(BRect(8,8,240,20),"txtfind",
                                           resmsg(rmFind),findword.String(),
                                           NULL);
    BTextControl *txtrepl=new BTextControl(BRect(8,28,240,40),"txtrepl",
                                           resmsg(rmReplace),
                                           replaceword.String(),NULL);
    BCheckBox *chkcase=new BCheckBox(BRect(8,48,240,60),"chkcase",
                                     resmsg(rmIgnoreCase),NULL);
    txtfind->SetDivider(40);
    AddChild(txtfind);
    txtrepl->SetDivider(40);
    AddChild(txtrepl);
    chkcase->SetValue(ignorecase?B_CONTROL_ON:B_CONTROL_OFF);
    AddChild(chkcase);
    AddChild(new BButton(BRect(256,8,336,20),"btnfind",resmsg(rmFind),
                         new BMessage(MSG_FIND)));
    AddChild(new BButton(BRect(256,38,336,58),"btnfind",resmsg(rmReplaceAll),
                         new BMessage(MSG_REPLACEALL)));
} 
//--------------------------------------------------------------------- 