#ifndef MAINWINDOW 
#define MAINWINDOW 
//--------------------------------------------------------------------- 
#include <Be.h> 
#include "BMemoView.h" 
#include "cccheck.h"
#include <be/support/UTF8.h>
#include "resmsg.h"
#include <be/interface/Font.h>
//--------------------------------------------------------------------- 
#define MAINWINDOW_TITLE            "BTinyEditor" 
#define MAINWINDOW_POSITION_LEFT    20 
#define MAINWINDOW_POSITION_TOP     40 
#define MAINWINDOW_POSITION_WIDTH   600 
#define MAINWINDOW_POSITION_HEIGHT  400 
#define MAINWINDOW_WINDOWSTYLE      (B_DOCUMENT_WINDOW) 

#define RESOURCEFILEPATH            "/boot/home/config/settings/BTinyEditor.cfg"
#define R_FRAME_WIDTH               1
#define R_FRAME_HEIGHT              2
#define R_JAPANESE                  3
#define R_FONTFAMILY                4
#define R_FONTSTYLE                 5
#define R_FONTSIZE                  6

//--------------------------------------------------------------------- 
#define MSG_OPEN      'mopn' 
#define MSG_SAVE      'msav' 
#define MSG_SAVEAS    'msva' 

#define MSG_CLOSED    'mcld' 
#define MSG_QUIT      'mqit' 
#define MSG_ADDEDITOR 'madd'
#define MSG_ACTIVATE  'mwac' 
#define MSG_SHOWFIND  'msfd'
#define MSG_FINDNEXT  'mfdn'
#define MSG_REPLACEFINDNEXT 'mraf'
#define MSG_REPLACEINSELECTION 'mris'

#define MSG_CCODECHANGE 'mccc'
#define MSG_CRETCHANGE  'mcrc'

#define MSG_LANGCHANGE  'mlng'
#define MSG_FONTMENU    'mftm'
#define MSG_SIZEMENU    'mfsm'
//--------------------------------------------------------------------- 
class BAppMainView : public BView 
{ 
public: 
    BMenu *savemenu;
    BMenu *fontmenu;
    BMenu *sizemenu;
    BMemoView *memo; 
    BAppMainView(BRect frame); 
}; 
//--------------------------------------------------------------------- 
class BAppMainWindow : public BWindow 
{ 
private: 
    BFilePanel *save_filepanel; 
    enum CCODETYPE fcode;
    enum CRETURNCODE fret;
    bool save_to_quit; 
    void SetFileName(BEntry *entry); 
    void SetCCodeToMenu(void);
    void SaveDataToResource(void);
public: 
    BPath *editingpath; 
    BAppMainView *mainview; 
    //----------------------------------------------------------------- 
    BAppMainWindow(BRect frame,const char *title); 
    ~BAppMainWindow(); 
    virtual void MessageReceived(BMessage *msg); 
    void OpenFile(BEntry *entry); 
    void SaveFile(BEntry *entry); 
    void FindWord(const BString &findword,const bool ignorecase);
    void ReplaceWord(const BString &replaceword);
    void ReplaceAll(const BString &findword,const BString &replaceword,
                    const bool ignorecase);
    void ReplaceInSelection(const BString &findword,
                    const BString &replaceword,const bool ignorecase);
    void ReplaceWords(const BString &findword,
                    const BString &replaceword,const bool ignorecase,
                    const int32 start,const int32 finish);
    void SetMemoFont(const font_family ffamily,
                     const font_style fstyle,const int32 size);
    //----------------------------------------------------------------- 
    bool QuitRequested();
    virtual void WindowActivated(bool active); 
}; 
//--------------------------------------------------------------------- 
#endif